-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}
M.type = "auxiliary"
M.relevantDevice = nil

local doorElectric = nil
local wlElectric = nil
local hasDoorBeenOpened = false

local function updateGFX(dt)
    local doorval = electrics.values[doorElectric]
    if doorval > 0.5 then hasDoorBeenOpened = true end
    if doorval < 0.5 and hasDoorBeenOpened then
        electrics.values[wlElectric] = 0
        hasDoorBeenOpened = false
    end
end

local function init(jbeamData)
  doorElectric = jbeamData.doorElectric or "open_doors"
  wlElectric = jbeamData.wlElectric or "toggle_wl"
end

M.init = init
M.updateGFX = updateGFX

return M
