local M = {}

M.enabled = true
local BOUNDED_TYPE = 2
local beams = {}
local function isnan(x) return x ~= x end

local function init()
	beams = {}
  for _,beam in pairs(v.data.beams) do
      if beam.beamType == BOUNDED_TYPE then table.insert(beams, beam) end
  end
end

local function reset()
  init()
end

--
local lastFrameCount = 0
local function updatePhysics()
    if not M.enabled then return end
    local frameCount = 0
    for _,beam in pairs(beams) do
            local length = obj:getBeamLength(beam.cid) /  obj:getBeamRestLength(beam.cid)
            local boundLengthUpper = 1 + beam.beamLongBound
            local boundLengthLower = 1 - beam.beamShortBound
            if length <= boundLengthLower or length >= boundLengthUpper then
                frameCount = frameCount + 1
                print(string.format("Beam is in bounded state %s->%s", v.data.nodes[beam.id1].name, v.data.nodes[beam.id2].name))
            end
    end
    lastFrameCount = frameCount
    
    if frameCount > 0 then
         print("-- PhysFrameEnd --")
    end
end

local function nop()
end

-- controller api --
M.init = init
M.reset = reset
M.update = updatePhysics
return M