local M = {}

local lastCouplerState = false
local couplerState = false
local couplerTag = "tow_hitch"

local function toggleCouplerState()
    couplerState = not couplerState
    if not couplerState then
        beamstate.toggleCouplers()
    else
        beamstate.activateAutoCoupling(couplerTag)
    end
    lastCouplerState = couplerState
end

local function onInit()
  couplerState = false
  lastCouplerState = couplerState
end

local function onReset()
    couplerState = false
    if lastCouplerState then toggleCouplerState() end -- immitate BeamNG's vanilla reset behaviour
end

local function updateGFX(dt)
end

-- public interface
M.toggleCouplerState = toggleCouplerState

M.onInit      = onInit
M.onReset     = onReset
M.updateGFX = updateGFX


return M