local M = {}

local fanspeed1 = 0
local fanspeed2 = 0
local fanspeed3 = 0

local spooldownRate = 0.5 -- 50% per second
local spoolupRate = 1.0 -- 100% per second
local fanRps = 3.5 -- 3 rotations per second

local function setRps(rps)
  fanRps = rps
end

local function onInit()
  electrics.values["fanspin1"] = 0
  electrics.values["fanspin2"] = 0
  electrics.values["fanspin3"] = 0
end

local function onReset()
	onInit()
end

local function updateGFX(dt)
--print("HI")
    local rps2angle = fanRps * 360
    if electrics.values["fan1"] ~= nil and electrics.values["fan1"]> 0.5  then
      fanspeed1 = math.min(fanspeed1 + (dt * spoolupRate), 1)
     else
      fanspeed1 = math.max(fanspeed1 - (dt * spooldownRate), 0)
    end
    electrics.values["fanspin1"] = (electrics.values["fanspin1"] + (dt * rps2angle * fanspeed1)) % 360
    
    if electrics.values["fan2"] ~= nil and electrics.values["fan2"]> 0.5  then
      fanspeed2 = math.min(fanspeed2 + (dt * spoolupRate), 1)
     else
      fanspeed2 = math.max(fanspeed2 - (dt * spooldownRate), 0)
    end
    electrics.values["fanspin2"] = (electrics.values["fanspin2"] + (dt * rps2angle * fanspeed2)) % 360
    
    if electrics.values["fan3"] ~= nil and electrics.values["fan3"]> 0.5  then
      fanspeed3 = math.min(fanspeed3 + (dt * spoolupRate), 1)
     else
      fanspeed3 = math.max(fanspeed3 - (dt * spooldownRate), 0)
    end
    electrics.values["fanspin3"] = (electrics.values["fanspin3"] + (dt * rps2angle * fanspeed3)) % 360
end

-- public interface
M.onInit      = onInit
M.onReset     = onReset
M.updateGFX = updateGFX

M.setRps = setRps

return M